(function() {
var GridDragHelperBase = ASPx.CreateClass(null, {
 maxRepeatScrollTimeout : 30,
 updateTargetPositionTimeout: 50,
 constructor: function() {
  this.isHorzDrag = false;
  this.savedPositions = { };
  this.rect = null;
 },
 GetActiveTargets: function() { return [ ]; },
 GetScrollHelper: function() { return null; },
 GetExtraCellWidth: function() { return 0; },
 GetCustomizationWindowElement: function() { return null; },
 GetScrollableControl: function() { 
  var helper = this.GetScrollHelper();
  return this.isHorzDrag ? helper.GetHorzScrollableControl() : helper.GetVertScrollableControl();
 },
 OnDragCreated: function(isHorzDrag) {
  if(this.NeedScrollOnDrag(isHorzDrag))
   this.InitializeDragScrolling(isHorzDrag);
 },
 InitializeDragScrolling: function(isHorzDrag) {
  this.isHorzDrag = isHorzDrag;
  this.SaveControlDimensions();
  this.mouseMoveHandler = function(e) { this.OnMouseMove(e); }.aspxBind(this);
  ASPx.Evt.AttachEventToDocument("mousemove", this.mouseMoveHandler);
 },
 SaveControlDimensions: function() {
  var scrollableControl = this.GetScrollableControl();
  var visibility = ASPx.GetElementDisplay(scrollableControl);
  ASPx.SetElementDisplay(scrollableControl, true);
  var scrollDivX = ASPx.GetAbsoluteX(scrollableControl);
  var scrollDivY = ASPx.GetAbsoluteY(scrollableControl);
  var width = scrollableControl.offsetWidth;
  var height = scrollableControl.offsetHeight;
  ASPx.SetElementDisplay(scrollableControl, visibility);
  this.SaveControlDimensionsCore(scrollDivX, width, scrollDivY, height);
 },
 SaveControlDimensionsCore: function(scrollDivX, width, scrollDivY, height) {
  this.rect = { 
   left: scrollDivX, 
   right: scrollDivX + width - this.GetExtraCellWidth(),
   top: scrollDivY,
   bottom: scrollDivY + height
  };
 },
 NeedScrollOnDrag: function(isHorzDrag) {
  var helper = this.GetScrollHelper();
  if(!helper || (isHorzDrag && !helper.HasHorzScroll()) || !isHorzDrag && !helper.HasVertScroll())
   return false;
  return ASPx.Browser.IE || ASPx.Browser.Firefox || helper.HasVertScroll();
 },
 OnMouseMove: function(e) {
  var pos = this.isHorzDrag ? ASPx.Evt.GetEventX(e) : ASPx.Evt.GetEventY(e);
  if(pos === this.savedPositions[this.isHorzDrag])
   return;
  var line = { 
   start:  this.isHorzDrag ? this.rect.left  : this.rect.top,
   end: this.isHorzDrag ? this.rect.right : this.rect.bottom
  };
  var isLeft = pos < line.start;
  var diff = isLeft ? line.start - pos : pos - line.end;
  if(diff <= 0) {
   this.CancelScrolling();
   return;
  }
  this.repeatScrollTimeout = diff < this.maxRepeatScrollTimeout ? this.maxRepeatScrollTimeout - diff : 1;
  this.scrollInc = isLeft ? -1 : 1;
  this.savedPositions[this.isHorzDrag] = pos;
  this.StartScrolling(this.isHorzDrag);
 },
 StartScrolling: function() {
  if(this.scrollingProcessing)
   return;
  this.scrollingProcessing = true;
  this.scrollHandler = this.RepeatScrolling();
 },
 CancelDrag: function() {
  if(this.mouseMoveHandler)
   ASPx.Evt.DetachEventFromDocument("mousemove", this.mouseMoveHandler);
  this.CancelScrolling();
 },
 CancelScrolling: function() {
  this.scrollingProcessing = false;
  this.scrollHandler = ASPx.Timer.ClearTimer(this.scrollHandler);
 },
 RepeatScrolling: function() {
  var scrollableControl = this.GetScrollableControl();
  if(this.isHorzDrag)
   scrollableControl.scrollLeft += this.scrollInc;
  else
   scrollableControl.scrollTop += this.scrollInc;
  return window.setTimeout(function() { this.scrollHandler = this.RepeatScrolling(); }.aspxBind(this), this.repeatScrollTimeout);
 },
 UpdateTargetPositionPostponed: function() {
  if(!this.GetActiveTargets().length)
   return;
  this.updateTargetPositionTimerID = ASPx.Timer.ClearTimer(this.updateTargetPositionTimerID);
  this.updateTargetPositionTimerID = window.setTimeout(function() { this.UpdateTargetPosition(); }.aspxBind(this), this.updateTargetPositionTimeout);
 },
 UpdateTargetPosition: function() { 
  var targets = this.GetActiveTargets();
  for(var i = 0; i < targets.length; i++)
   targets[i].UpdatePosition();
 },
 OnHeaderTargetAllowed: function(targetElement, x, y) {
  if(!this.rect)
   return true;
  var custWin = this.GetCustomizationWindowElement();
  var inRect = x >= this.rect.left && x <= this.rect.right;
  return inRect || custWin === targetElement;
 },
 UpdateScrollableControlsOnDrag: function(src) {
  this.UpdateTargetPositionPostponed();
  var helper = this.GetScrollHelper();
  var contentScrollDiv = helper.GetScrollDiv(helper.GetContentTable());
  if(contentScrollDiv === src && helper.HasVertScroll()) {
   var scrollDivs = [ helper.GetScrollDiv(helper.GetHeaderTable()), helper.GetScrollDiv(helper.GetFooterTable()) ];
   for(var i = 0; i < scrollDivs.length; i++)
    if(scrollDivs[i])
     scrollDivs[i].scrollLeft = src.scrollLeft;
  }
 }
});
var BatchEditApi = ASPx.CreateClass(null, {
 constructor: function(owner) {
  this.owner = owner;
 },
 GetHelper: function() { return this.owner.GetBatchEditHelper(); },
 GetColumnIndex: function(column) {  },
 CreateCellInfo: function(key, column) {  },
 SetCellValueCore: function(key, column, value, displayText, cancelCellHighlighting) {
  var helper = this.GetHelper();
  var columnIndex = this.GetColumnIndex(column);
  if(!helper || columnIndex === null) 
   return;
  if(!helper.IsValidRecord(key))
   return;
  if(helper.IsEditingCell(key, columnIndex))
   return;
  if(!ASPx.IsExists(displayText))
   displayText = helper.GetColumnDisplayTextByEditor(value, columnIndex);
  if(helper.IsCheckColumn(columnIndex))
   displayText = helper.GetCheckColumnDisplayText(value, columnIndex);
  if(helper.IsColorEditColumn(columnIndex))
   displayText = helper.GetColorEditColumnDisplayText(value, columnIndex);
  helper.SetCellValue(key, columnIndex, value, displayText, cancelCellHighlighting);
  helper.ResetCellValidationState(key, columnIndex);
  helper.UpdateSyncInput(); 
  helper.UpdateItem(key, [columnIndex], false, false, true);
  helper.UpdateCommandButtonsEnabled();
  helper.RemoveRecordErrorIfHasNoChanges(key);
 },
 GetColumnDisplayText: function(column, value) {
  var helper = this.GetHelper();
  var columnIndex = this.GetColumnIndex(column);
  if(!helper || columnIndex === null) 
   return;
  return helper.GetColumnDisplayTextByEditor(value, columnIndex);
 },
 GetCellValueCore: function(key, column, initial) {
  var helper = this.GetHelper();
  var columnIndex = this.GetColumnIndex(column);
  if(!helper || columnIndex === null) return;
  return helper.GetCellValue(key, columnIndex, initial);
 },
 GetCellTextContainerCore: function(key, column) {
  var helper = this.GetHelper();
  var columnIndex = this.GetColumnIndex(column);
  if(!helper || columnIndex === null) return;
  return helper.GetCellTextContainer(key, columnIndex);
 },
 HasChangesCore: function(key, column) {
  var helper = this.GetHelper();
  if(!helper) return false;
  var columnIndex = this.GetColumnIndex(column);
  return helper.HasChanges(key, columnIndex);
 },
 ResetChangesCore: function(key, columnIndex) {
  var helper = this.GetHelper();
  if(!helper) return;
  helper.ResetChanges(key, columnIndex);
 },
 StartEditCore: function(key, columnIndex) {
  var helper = this.GetHelper();
  if(!helper) return;
  helper.StartEdit(key, columnIndex);
 },
 EndEdit: function() {
  var helper = this.GetHelper();
  if(!helper || helper.GetFocusHelper().lockUserEndEdit) 
   return;
  helper.EndEdit();
 },
 MoveFocusBackward: function() {
  var helper = this.GetHelper();
  if(!helper) return;
  return helper.GetFocusHelper().MoveFocusPrev();
 },
 MoveFocusForward: function() {
  var helper = this.GetHelper();
  if(!helper) return;
  return helper.GetFocusHelper().MoveFocusNext();
 },
 IsColumnEdited: function(column) {
  var helper = this.GetHelper();
  if(!helper || !column) return false;
  return helper.IsColumnEdited(this.GetColumIndex(column));
 },
 ValidateItems: function(validateOnlyModified, validateOnCurrentPageOnly) {
  var helper = this.GetHelper();
  if(!helper) return false;
  return !!helper.UserValidateItems(null, validateOnlyModified, validateOnCurrentPageOnly).isValid;
 },
 ValidateRecordCore: function(key) {
  var helper = this.GetHelper();
  if(!helper) return false;
  return !!helper.UserValidateItems(key).isValid;
 }, 
 IsDeletedRecordCore: function(key) {
  var helper = this.GetHelper();
  return helper ? helper.IsDeletedRecord(key) : false;
 },
 IsNewRecordCore: function(key) {
  var helper = this.GetHelper();
  if(!helper) return false;
  return helper.IsNewRecord(key);
 },
 GetEditCellInfo: function() {
  var helper = this.GetHelper();
  if(!helper || !helper.IsEditing()) 
   return null;
  return this.CreateCellInfo(helper.GetEditingRecordKey(), helper.GetFocusedColumn());
 },
 AddNewRecordCore: function(parentRecordKey) {
  var helper = this.GetHelper();
  if(helper)
   helper.AddNewRecord(parentRecordKey);
 },
 DeleteRecordCore: function(key) {
  var helper = this.GetHelper();
  if(helper)
   helper.DeleteItem(key);
 },
 RecoverRecordCore: function(key) {
  var helper = this.GetHelper();
  if(helper)
   helper.RecoverRecord(key);
 },
 GetRecordKeys: function(includeDeleted) {
  var helper = this.GetHelper();
  if(!helper) return [ ];
  return helper.GetRecordKeys(!includeDeleted);
 },
 GetInsertedRecordKeys: function() {
  var helper = this.GetHelper();
  if(!helper) return [ ];
  var indices = helper.GetInsertedRecordKeys();
  if(helper.IsNewItemOnTop())
   indices.reverse();
  return indices;
 },
 GetDeletedRecordKeys: function() {
  var helper = this.GetHelper();
  if(!helper) return [ ];
  return helper.deletedItemKeys.slice();
 },
 GetUpdatedRecordKeys: function() {
  var helper = this.GetHelper();
  if(!helper) return [ ];
  return ASPx.GetObjectKeys(helper.updatedValues);
 },
 GetUnsavedChanges: function() {
  var helper = this.GetHelper();
  if(!helper) return { };
  return helper.GetChangedValuesInfo();
 }
});
var GridStyleHelperBase = ASPx.CreateClass(null, {
 ClearItemStyleKey: "items",
 ErrorItemHtmlKey: "ei",
 BatchEditCellKey: "bec",
 BatchEditModifiedCellKey: "bemc",
 BatchEditMergedModifiedCellKey: "bemergmc",
 BatchEditDeletedItemKey: "bedi",
 FocusedCellKey: "fc",
 InitCellStyleKey: "initial",
 AppliedBatchEditCellStylKey: "batchEdit",
 AppliedFocusedCellStyleKey: "focused",
 GetStyles: function() { return null; },
 GetStyleInfo: function(styleKey, columnIndex) {
  var info = this.GetStyleInfoCore(styleKey, columnIndex);
  if(info)
   info.styleKey = styleKey;
  return info;
 },
 GetStyleInfoCore: function(styleKey, keyPostFix) {
  var styles = this.GetStyles();
  if(!styles)
   return null;
  if(ASPx.IsExists(keyPostFix)) {
   var key = styleKey + keyPostFix;
   if(styles.hasOwnProperty(key))
    return styles[key];
  }
  return styles[styleKey];
 },
 GetCellStyleKeys: function() {
  var result = [];
  result.push(this.AppliedBatchEditCellStylKey);
  result.push(this.AppliedFocusedCellStyleKey);
  return result;
 },
 UpdateCellBatchEditStyle: function(style, cell) { this.UpdateCellStyle(this.AppliedBatchEditCellStylKey, style, cell); },
 UpdateCellFocusedStyle: function(style, cell) { this.UpdateCellStyle(this.AppliedFocusedCellStyleKey, style, cell); },
 UpdateCellStyle: function(styleKey, style, cell) {
  if(!cell) return;
  this.EnsureCellStyles(cell);
  cell.appliedStyles[styleKey] = this.GetCellStyleToApply(style);
  this.ApplyCellStyles(cell);
 },
 EnsureCellStyles: function(cell) {
  if(cell.appliedStyles)
   return;
  cell.appliedStyles = { }; 
  cell.appliedStyles[this.InitCellStyleKey] = this.CreateEmptyCellStyle(cell.className, cell.style.cssText);
  var keys = this.GetCellStyleKeys();
  for(var i = 0; i < keys.length; i++)
   cell.appliedStyles[keys[i]] = this.CreateEmptyCellStyle();
 },
 CreateEmptyCellStyle: function(className, cssText) {  
  className = className || "";
  cssText = cssText || "";
  return { className: className, cssText: cssText};
 },
 GetCellStyleToApply: function(style) {
  var result = this.CreateEmptyCellStyle();
  if(style) {
   result.className = style.css || "";
   result.cssText = style.style || "";
  }
  return result;
 },
 ApplyCellStyles: function(cell) {
  var className = "";
  var cssText = "";
  for(var key in cell.appliedStyles) {
   if(!cell.appliedStyles.hasOwnProperty(key)) continue;
   var style = cell.appliedStyles[key];
   if(!style) continue;
   if(style.className)
    className += " " + style.className;
   if(style.cssText)
    cssText += ";" + style.cssText;
  }
  cell.className = className;
  cell.style.cssText = cssText;
 },
 AddToBatchEditStyle: function(cell, styles) { this.AddToCellStyleCore(cell, this.AppliedBatchEditCellStylKey, styles); },
 AddToInitialStyle: function(cell, styles) { this.AddToCellStyleCore(cell, this.InitCellStyleKey, styles); },
 AddToCellStyleCore: function(cell, styleKey, styles) {
  if(!styles || !cell) return;
  this.EnsureCellStyles(cell);
  var style = cell.appliedStyles[styleKey];
  if(!style) return;
  var fakeCell = document.createElement("TD");
  fakeCell.style.cssText = style.cssText || "";
  for(var property in styles) {
   if(styles.hasOwnProperty(property)) {
    var value = styles[property];
    fakeCell.style[property] = value + (typeof (value) == "number" ? "px" : "");
   }
  }
  style.cssText = fakeCell.style.cssText;
  this.ApplyCellStyles(cell);
 },
 ChangeCellInitialClass: function(cell, className, add, preventApply) {
  if(!cell || !cell.appliedStyles)
   return;
  var hasClass = cell.appliedStyles.initial.className.indexOf(className) > -1;
  if(hasClass && !add)
    cell.appliedStyles.initial.className =  cell.appliedStyles.initial.className.replace(className, "");
  if(!hasClass && add)
    cell.appliedStyles.initial.className += " " + className;
  if(!preventApply)
   this.ApplyCellStyles(cell);
 },
 GetEmptyCellStyle: function() { return this.CreateEmptyCellStyle(); },
 GetBatchEditCellStyle: function() { return this.GetStyleInfo(this.BatchEditCellKey); },
 GetBatchEditModifiedCellStyle: function(columnIndex) { return this.GetStyleInfo(this.BatchEditModifiedCellKey, columnIndex); },
 GetBatchEditMergedModifiedCellStyle: function() { return this.GetStyleInfo(this.BatchEditMergedModifiedCellKey); },
 GetFocusedCellStyle: function(style) { return this.GetStyleInfo(this.FocusedCellKey); },
 IsBatchEditCellStyle: function(style) { return this.CheckStyleInfoByKey(style, this.BatchEditCellKey); },
 IsBatchEditModifiedCellStyle: function(style) { return this.CheckStyleInfoByKey(style, this.BatchEditModifiedCellKey); },
 IsBatchEditMergedModifiedCellStyle: function(style) { return this.CheckStyleInfoByKey(style, this.BatchEditMergedModifiedCellKey); },
 IsFocusedCellStyle: function(style) { return this.CheckStyleInfoByKey(style, this.FocusedCellKey); },
 GetClearItemStyle: function() { return this.GetStyleInfo(this.ClearItemStyleKey); },
 GetBatchEditDeletedItemStyle: function() { return this.GetStyleInfo(this.BatchEditDeletedItemKey); },
 IsClearItemStyle: function(style) { return this.CheckStyleInfoByKey(style, this.ClearItemStyleKey); },   
 IsBatchEditDeletedItemStyle: function(style) { return this.CheckStyleInfoByKey(style, this.BatchEditDeletedItemKey); },   
 CheckStyleInfoByKey: function(styleInfo, key) {
  if(!styleInfo)
   return false;
  return styleInfo.styleKey == key;
 },
 ApplyElementStyle: function(element, styleInfo, skipInitialStyle){
  if(!element) return;
  if(!skipInitialStyle) {
   if(!ASPx.IsExists(element.initialClassName))
    element.initialClassName = element.className;
   if(!ASPx.IsExists(element.initialCssText))
    element.initialCssText = element.style.cssText;
   element.className = element.initialClassName;
   element.style.cssText = element.initialCssText;
  }
  if(styleInfo) {
   element.className += " " + styleInfo.css;
   element.style.cssText += " " + styleInfo.style;
  }
 },
 GetErrorItemHtml: function() {
  var styles = this.GetStyles();
  if(!styles)
   return null;
  return styles[this.ErrorItemHtmlKey];
 }
});
var GridCommonUtils = {
 BacthEditLockFocusEventsTriggerTimeout: 50,
 NeedSaveActiveElement: function (control) { return ASPx.Browser.IE || (ASPx.Browser.WindowsPhonePlatform && ASPx.Browser.Edge); },
 IsBatchEditMode: function (control) { return control.GetBatchEditHelper && !!control.GetBatchEditHelper(); },
 IsInput: function (element) {
  if (!element) return false;
  return element.tagName == "INPUT" || element.tagName == "TEXTAREA";
 },
 SaveActiveElement: function (control) {
  if (!this.NeedSaveActiveElement(control)) return;
  var activeElement = ASPx.GetActiveElement();
  var isBatchEditing = this.IsBatchEditMode(control);
  var isInput = this.IsInput(activeElement);
  if (!activeElement || !isInput && !isBatchEditing || !ASPx.GetIsParent(control.GetMainElement(), activeElement))
   return;
  control.activeElementSettings = { activeElement: activeElement };
  if (isInput)
   control.activeElementSettings.selInfo = ASPx.Selection.GetInfo(activeElement);
  if (isBatchEditing)
   this.LockBatchEditFocusEvents(control);
 },
 RestoreActiveElement: function (control) {
  var settings = control.activeElementSettings;
  if (!settings) return;
  var oldElement = settings.activeElement;
  if (!ASPx.IsExistsElement(oldElement) || oldElement === ASPx.GetActiveElement()) return;
  oldElement.focus();
  if (settings.selInfo)
   ASPx.Selection.Set(oldElement, settings.selInfo.startPos, settings.selInfo.endPos);
  delete control.activeElementSettings;
  this.UnLockBatchEditFocusEvents(control);
 },
 LockBatchEditFocusEvents: function (control) { control.BatchEditFocusEventsLocked = true; },
 UnLockBatchEditFocusEvents: function (control) {
  ASPx.Timer.ClearTimer(control.bacthEditLockFocusEventsTriggerID);
  if (control.BatchEditFocusEventsLocked)
   control.bacthEditLockFocusEventsTriggerID = window.setTimeout(function () { delete control.BatchEditFocusEventsLocked; }, this.BacthEditLockFocusEventsTriggerTimeout);
 },
 IsBatchEditFocusEventsLocked: function (control) { return !!control.BatchEditFocusEventsLocked; }
};
ASPx.GridDragHelperBase = GridDragHelperBase;
ASPx.BatchEditApi = BatchEditApi;
ASPx.GridStyleHelperBase = GridStyleHelperBase;
ASPx.GridCommonUtils = GridCommonUtils;
})();
